/******************************************************
 *  Systemy Mikroprocesorowe w Sterowaniu,  WEiTI PW 	*
 *  ZL27ARM: PROJEKT_03 programy asemblerowe  			 	*
 ******************************************************/
#include "stm32f10x.h"
#include <stdbool.h> 		// true, false
#include <stdio.h>
#include ".\..\Drivers\LCD1602\lcd_1602.h"
#include "AsmCode.h"

int  RCC_Config(void);
void GPIO_Config(void);

int main(void) {
	int k;
	int GPIO_Pin_x, liczba, kursor=0, sum, delay = 2000000;
  unsigned char str2disp[5] = {"0\0"};
	bool parity;
	int array[14] = {-1,5,3,8,-10,23,6,5,24,-10,11,23,14,16};
	
  //konfiguracja systemu
  RCC_Config();		
  GPIO_Config(); 
  GPIO_ResetBits(GPIOB, 0xFF00u);// zgasimy wszystkie diody LED
	LCD_Initialize();              //inicjalizacja wysietlacza

// -------------------- Najwiksza w tablicy -------------------
	LCD_WriteTextXY((unsigned char *)"Najwi\5ksza,nr \0",0,1);
	k = maxLocation((unsigned int *) array, sizeof(array)/sizeof(int));
	k=maxLocation((unsigned int *)array, sizeof(array)/sizeof(int));
	sprintf((char *)str2disp,"%2i",k);
	LCD_WriteText(str2disp);

// ---------------------- Bit parzystosci ---------------------
	for(k=0; k < 256; k++){
		LCD_SendCommand(LCD_HOME);
		LCD_WriteBin(k, 8);
		parity = parityBit(k);		// bit parzystosc
		sprintf((char *)str2disp,"%2i",parity);
		LCD_WriteText(str2disp);
		delay_us(8000000);
	}
// --------------------- Liczby Armstronga --------------------
	LCD_SendCommand(LCD_CLEAR);
	LCD_WriteText((unsigned char *)"Ilosc liczb:\0"); //wyswietl tekst pierwszej linii
	sum=0;
	for(k = 1000; k < 10000; k++){
		liczba=k;
		if(Armstrong(k) == 1){
				sum++;
				sprintf((char *)str2disp,"%2i",liczba);
				LCD_WriteTextXY(str2disp,kursor,1);
			  kursor += 6;
		}
	}	
	sprintf((char *)str2disp,"%2i",sum);
	LCD_WriteTextXY(str2disp,12,0);
// ------------------------------------------------------------
	
	while (1) {
   // ************************* LEDy lewo - prawo ************************
		for (k=0; k<9; k++) {
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_SET);
			GPIO_Write(GPIOE, k);
			delay_us(delay);
			GPIO_Pin_x = GPIO_Pin_8 << (k);
		}
		for (k=0; k<9; k++) {
			GPIO_WriteBit(GPIOB, GPIO_Pin_x, Bit_RESET);
			GPIO_Write(GPIOE, k);
			delay_us(delay);
			GPIO_Pin_x = GPIO_Pin_8 << (k);
		} 
	}
}
//------------ konfiguracja RCC: sygnaly taktujace ------------
int RCC_Config(void) {
  ErrorStatus HSEStartUpStatus;                          // zmienna opisujaca rezultat uruchomienia HSE

  RCC_DeInit();                                          // RCC na 'default reset state'
  RCC_HSEConfig(RCC_HSE_ON);                             // wlacz HSE
  HSEStartUpStatus = RCC_WaitForHSEStartUp();            // czekaj na gotowosc HSE
  if(HSEStartUpStatus == SUCCESS) {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);//
    FLASH_SetLatency(FLASH_Latency_2);                   // zwloka Flasha: 2 takty dla 72MHz
    RCC_HCLKConfig(RCC_SYSCLK_Div1);                     // HCLK=SYSCLK
    RCC_PCLK2Config(RCC_HCLK_Div1);                      // PCLK2=HCLK
    RCC_PCLK1Config(RCC_HCLK_Div2);                      // PCLK1=HCLK/2
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9); // PLLCLK = HSE*9 czyli 8MHz * 9 = 72 MHz
    RCC_PLLCmd(ENABLE);                                  // wlacz PLL
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);  // czekaj na uruchomienie PLL
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);           // ustaw PLL jako zrodlo sygnalu zegarowego
    while(RCC_GetSYSCLKSource() != 0x08);                // czekaj az PLL bedzie sygnalem zegarowym systemu
		// konfiguracja sygnalow taktujacych uzywanych peryferii 
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);// wlacz taktowanie portu GPIO B ( LEDy  )
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);// wlacz taktowanie portu GPIO C (LCD1602)
		return 0;
  }
	else
		return 1;
}
//------------------ konfiguracja portow GPIO -----------------
void GPIO_Config(void) {
  GPIO_InitTypeDef  GPIO_InitStructure; 

  // LED1 ... LED8 na plytce
  GPIO_InitStructure.GPIO_Pin = 0xFF00u; 	// piny 15,14,...9,8
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      // wyjscie w trybie push-pull
  GPIO_Init(GPIOB, &GPIO_InitStructure);
}

